import csv
import json
import os
import zipfile

result = 0
headers = 'id,expense,wealth,amount,outcome'.split(',')
with zipfile.ZipFile('bank.zip') as zipfile:
    zipfile.extractall('temp_folder')
    for dirpath, dirnames, filenames in os.walk('temp_folder'):
        # print([dirpath, dirnames, filenames])
        if 'report.json' in filenames:
            with open(f'{dirpath}/report.json') as owner_file:
                owner = json.load(owner_file)
                # print(owner)
                if owner['who is Mr'] == 'dwarf':
                    # print(dirnames)
                    for year in [x for x in dirnames if 1900 <= int(x) <= 2020]:
                        for csv_file in os.listdir(f'{dirpath}/{year}'):
                            with open(f'{dirpath}/{year}/{csv_file}') as f:
                                reader = csv.DictReader(f, fieldnames=headers, delimiter=',')
                                for item in reader:
                                    if item['expense'] == 'purchase' and 'gold' in item['wealth']:
                                        result += int(item['amount'])
print(result)