#include <algorithm>
#include <vector>
#include <iostream>
#include <cassert>

using namespace std;
using li = long long;

const li INF = 1e18; 

int main() {
	int n;
	cin >> n;
	assert(n <= 2e5);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
		assert(a[i] <= 1e7);
	}
	int max_val = *max_element(a.begin(), a.end());
	vector<li> f(max_val + 1, -INF);
	for (int i = 0; i < n; ++i) {
		vector<int> divs; 
		for (int d = 1; d * d <= a[i]; ++d) {
			if (a[i] % d == 0) {
				divs.push_back(d);
				divs.push_back(a[i] / d);
			}
		}
		li max_profit = 0;
		if (i) {
			for (int d: divs) {
				max_profit = max(max_profit, f[d] + d);
			}
		}
		for (int d: divs) {
			f[d] = max(f[d], max_profit);
		}
	}
	cout << f[a[n - 1]];
}
