import csv
import json
import os
import shutil
import zipfile

outcome = benefit = 0
filename = input()
name = input()
tax_year = int(input())
tax = int(input())
headers = 'id,expense,wealth,amount,outcome'.split(',')
with zipfile.ZipFile(filename) as zipfile:
    zipfile.extractall('temp_folder')
    for dirpath, dirnames, filenames in os.walk('temp_folder'):
        # print([dirpath, dirnames, filenames])
        if 'report.json' in filenames:
            with open(f'{dirpath}/report.json') as owner_file:
                owner = json.load(owner_file)
                # print(owner)
                if owner['owner'] == name:
                    benefit = owner['benefits']
                    # print(dirnames)
                    for year in [x for x in dirnames]:
                        if int(year) == tax_year:
                            for csv_file in os.listdir(f'{dirpath}/{year}'):
                                with open(f'{dirpath}/{year}/{csv_file}') as f:
                                    reader = csv.DictReader(f, fieldnames=headers, delimiter=',')
                                    for item in reader:
                                        if item['expense'] == 'sale':
                                            outcome += int(item['outcome'])
print(int(outcome * (tax - benefit) / 100) if tax - benefit > 5 else
      int(outcome / 20))
shutil.rmtree('temp_folder')
